# encoding: utf-8
# WARNING! Do not edit! http://waf.googlecode.com/git/docs/wafbook/single.html#_obtaining_the_waf_file

import re
from waflib import Utils
from waflib.Tools import fc,fc_config,fc_scan
from waflib.Configure import conf
from waflib.Tools.compiler_fc import fc_compiler
fc_compiler['linux'].append('fc_solstudio')
def find_solstudio(conf):
	fc=conf.find_program(['sunf95','f95','sunf90','f90'],var='FC')
	fc=conf.cmd_to_list(fc)
	conf.get_solstudio_version(fc)
	conf.env.FC_NAME='SOL'
def solstudio_flags(conf):
	v=conf.env
	v['FCFLAGS_fcshlib']=['-Kpic']
	v['FCFLAGS_DEBUG']=['-w3']
	v['LINKFLAGS_fcshlib']=['-G']
	v['FCSTLIB_MARKER']='-Bstatic'
	v['FCSHLIB_MARKER']='-Bdynamic'
	v['SONAME_ST']='-h %s'
def solstudio_modifier_platform(conf):
	dest_os=conf.env['DEST_OS']or Utils.unversioned_sys_platform()
	solstudio_modifier_func=getattr(conf,'solstudio_modifier_'+dest_os,None)
	if solstudio_modifier_func:
		solstudio_modifier_func()
def get_solstudio_version(conf,fc):
	version_re=re.compile(r"Sun Fortran 95 *(?P<major>\d*)\.(?P<minor>\d*)",re.I).search
	cmd=fc+['-V']
	out,err=fc_config.getoutput(conf,cmd,stdin=False)
	if out:match=version_re(out)
	else:match=version_re(err)
	if not match:
		conf.fatal('Could not determine the Sun Studio Fortran version.')
	k=match.groupdict()
	conf.env['FC_VERSION']=(k['major'],k['minor'])
def configure(conf):
	conf.find_solstudio()
	conf.find_ar()
	conf.fc_flags()
	conf.solstudio_flags()
	conf.solstudio_modifier_platform()

conf(find_solstudio)
conf(solstudio_flags)
conf(solstudio_modifier_platform)
conf(get_solstudio_version)